Device 16F628A
all_digital true
declare XTAL 20
declare LCD_ENPIN PORTb.3
declare LCD_rsPIN PORTb.0
DIM In[15] AS BYTE  
dim m[7] as byte  
dim CallSign[11] as byte
dim CallSign_l as byte
dim Freq_d as word
dim Speed_d as word
dim Interval as word
dim x as byte
dim y as byte
dim z as byte
dim s as byte
dim l as byte
DIM mi AS BYTE
dim se as word
dim temp as word

Boot:
          clear
          cls
          print at 1,1,"CALLGEVE"
          print at 2,1,"R v2.1"
          delayms 1000
          cls
          gosub Lees_NVRAM
          gosub settings
          if porta.0 = 0 then goto invoer
          print str callsign
          print at 2,2,"0:00"
          temp = 0
WachtLus:
          if porta.1 = 0 then 
            gosub seinen
            for temp = 1 to (Interval * 10)
              delayms 90
              Se = INTERVAL - TEMP /10
              Mi = Se / 60
              Se = Se - (Mi * 60) 
              IF SE < 10 THEN 
               print at 2,2,dec mi,":0",dec se," "
               ELSE print at 2,2,dec mi,":",dec se," " 
              ENDIF
            Next temp
          endif
          goto wachtlus
           
Settings:
          HSEROUT [13,10,10]
          HSEROUT ["Callsign: ",str callsign,13,10]
          HSEROUT ["Snelheid: ",dec speed_d," ms",13,10]
          HSEROUT ["Toonh.  : ",dec freq_d," Hz",13,10]
          HSEROUT ["Interval: ",dec Interval," sec",13,10,10]
          return
Invoer:
          HSEROUT ["CONFIG>"]
          print at 1,1,"CONFIG"
          for x=1 to 14
            hserin [in[x]]
            if In[x] = 13 then goto InvoerControle
            HSEROUT [In[x]]
          next x
          Goto FouteInvoer

InvoerControle:          
          if in[1] = "C" then goto Set_Callsign
          if in[1] = "T" then goto Set_freq
          if in[1] = "S" then goto Set_speed
          if In[1] = "I" then goto set_Interval
          if in[1] = "O" then goto Opslaan_NVRAM
          if in[1] = "M" then goto Seincall
          if in[1] = "?" then goto Hulp
          Goto FouteInvoer

Set_CallSign:
          if x > 11 then goto fouteinvoer
          z=0
          for y = 3 to ( x - 1 )
           callsign[z] = in[y]
           z = z + 1
           next y
          callsign[z] = 0
          gosub settings
          gosub seinen
          goto invoer
Set_Speed:
          if x > 6 then goto fouteinvoer
          gosub stringomzet
          if temp < 1 then goto fouteinvoer
          speed_d = temp
          gosub settings
          goto invoer
Set_Freq:
          if x > 7 then goto fouteinvoer
          gosub stringomzet
          freq_d = temp
          gosub settings
          goto invoer
Set_Interval:
          if x > 6 then goto fouteinvoer
          gosub stringomzet
          Interval = temp
          gosub settings
          goto invoer

StringOmzet:
          in[1]= "0"
          in[2]= "0"
          temp = VAL(in,DEC)
          return

Lees_NVRAM:
          z = eread 50
          if z = 99 then 
            speed_d = eread 20
            freq_d = eread 30
            interval = eread 40
            for x = 0 to 9
             Callsign[x]= eread x
            next x
          else
            str callsign = "PA1RUM",0
            speed_d = 68
            freq_d = 1250
            interval = 10
          endif
          return  

Opslaan_NVRAM:
            ewrite 50,[99]
            ewrite 20,[speed_d]
            ewrite 30,[freq_d]
            ewrite 40,[Interval]
            for x = 0 to 9
             ewrite x,[Callsign[x]]
            next x
            HSEROUT [10,13,"Opgeslagen!",10,13]
            goto invoer
SeinCall:
            gosub seinen
            gosub settings
            goto invoer
Seinen:   
          high porta.2 
          for x = 0 to 9
            s = callsign[x]
            if s = 0 then 
              low porta.2
              return
            endif
            gosub stringmorse
            for y = 1 to m[0]
              if m[y]="." then freqout porta.3 , speed_d , freq_d
              if m[y]="-" then freqout porta.3 , (speed_d * 3) , freq_d
              if m[y]=" " then delayms (speed_d * 4)
              delayms speed_d
            next y
            delayms speed_d * 2
          next x
          return

Hulp:
          HSEROUT [13,10,10,"C [Call]",13,10] 
          HSEROUT ["T [toonhoogte]",13,10]
          HSEROUT ["S [snelheid]",13,10]
          HSEROUT ["I [interval]",13,10]
          HSEROUT ["M Seinen",13,10]
          HSEROUT ["O Opslaan",13,10,10]
          goto invoer
          
FouteInvoer:
          HSEROUT [13,10,"Fout ?=help",13,10]
          gosub settings
          goto invoer
          
StringMorse:
          If S = "A" then str m = 2,".-"
          If S = "B" then str m = 4,"-..."
          If S = "C" then str m = 4,"-.-."
          If S = "D" then str m = 3,"-.."
          If S = "E" then str m = 1,"."
          If S = "F" then str m = 4,"..-."
          If S = "G" then str m = 3,"--."
          If S = "H" then str m = 4,"...."
          If S = "I" then str m = 2,".."
          If S = "J" then str m = 4,".---"
          If S = "K" then str m = 3,"-.-"
          If S = "L" then str m = 4,".-.."
          If S = "M" then str m = 2,"--"
          If S = "N" then str m = 2,"-."
          If S = "O" then str m = 3,"---"
          If S = "P" then str m = 4,".--."
          If S = "Q" then str m = 4,"--.-"
          If S = "R" then str m = 3,".-."
          If S = "S" then str m = 3,"..."
          If S = "T" then str m = 1,"-"
          If S = "U" then str m = 3,"..-"
          If S = "V" then str m = 4,"...-"
          If S = "W" then str m = 3,".--"
          If S = "X" then str m = 4,"-..-"
          If S = "Y" then str m = 4,"-.--"
          If S = "Z" then str m = 4,"--.."
          If S = "1" then str m = 5,".----"
          If S = "2" then str m = 5,"..---"
          If S = "3" then str m = 5,"...--"
          If S = "4" then str m = 5,"....-"
          If S = "5" then str m = 5,"....."
          If S = "6" then str m = 5,"-...."
          If S = "7" then str m = 5,"--..."
          If S = "8" then str m = 5,"---.."
          If S = "9" then str m = 5,"----."
          If S = "0" then str m = 5,"-----"
          if s = " " then str m = 1," "
          if s = "/" then str m = 5,"-..-."
          return         
End
